(function($){
    var plg_fields_location_class = function() {
        var vars = {
            timer:false
        };
        this.fields = {};
        this.maps = {};
        this.markers = {};
        var root = this;
        var construct = function() {
            
        };
        this.registerField = function(id,element,target) {
            if(document.getElementById(element)) {
                return;
            }
            var t = document.getElementById(target);  
            $(t).after($('<div id="'+element+'"/>'));
            this.fields[id] = {
                element:document.getElementById(element),
                target:t,
                watch:'target',
                method:'setupMap',
                setup:false
            };
            if(!vars.timer) {
                startTimer();
            }
        };
        this.registerDisplay = function(id,element) {
            this.fields[id] = {
                element:document.getElementById(element),
                watch:'element',
                method:'setupDisplay',
                setup:false
            };
            if(!vars.timer) {
                startTimer();
            }
        };
        var startTimer = function() {
            var restart = false;
            $.each(root.fields,function(id,o){
                if(o.setup) {
                    return;
                }
                if(o[o.watch] === null || o[o.watch].offsetParent === null) {
                    restart = true;
                } else {
                    root[o.method](id);
                }
            });
            if(restart) {
                setTimeout(startTimer,1000);
            } else {
                vars.timer = false;
            }
        };
        this.setupMap = function(id) {
            this.setupDisplay(id);
            root.maps[id].addListener('click',function(event){
                var latlon = [event.latLng.lat(),event.latLng.lng()];
                $(root.fields[this.plg_fields_location_id].target).val(latlon.join(","));
                root.markers[this.plg_fields_location_id].setPosition(event.latLng);
            });
            root.fields[id].setup = true;
        };
        this.setupDisplay = function(id) {
            var options = Joomla.getOptions('plg_fields_location_'+id);
            var mapOptions = {
                zoom:parseInt(options.zoom),
                center:new google.maps.LatLng(options.center[0],options.center[1]),
                mapTypeId:google.maps.MapTypeId[options.mapTypeId]
            };
            root.maps[id] = new google.maps.Map(root.fields[id].element,mapOptions);
            root.maps[id].plg_fields_location_id = id;
            root.markers[id] = new google.maps.Marker({position:mapOptions.center,map:root.maps[id]});
            root.fields[id].setup = true;            
        };
        construct();
    };
    $(document).ready(function(){
        window.plg_fields_location = new plg_fields_location_class();
    });
})(jQuery);
